/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type EmergencyVehicle from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class EmergencyVehicle extends Sequence {
    
    /**
     * The default constructor.
     */
    public EmergencyVehicle()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public EmergencyVehicle(LightBarInUse lightBarInUse, 
		    SireneInUse sireneInUse, 
		    EmergencyResponseType emergencyResponseType)
    {
	setLightBarInUse(lightBarInUse);
	setSireneInUse(sireneInUse);
	setEmergencyResponseType(emergencyResponseType);
    }
    
    /**
     * Construct with required components.
     */
    public EmergencyVehicle(EmergencyResponseType emergencyResponseType)
    {
	setEmergencyResponseType(emergencyResponseType);
    }
    
    public void initComponents()
    {
	mComponents[0] = LightBarInUse.unavailable;
	mComponents[1] = SireneInUse.unavailable;
	mComponents[2] = EmergencyResponseType.none;
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[3];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return LightBarInUse.unavailable;
	    case 1:
		return SireneInUse.unavailable;
	    case 2:
		return EmergencyResponseType.none;
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "lightBarInUse"
    public LightBarInUse getLightBarInUse()
    {
	return (LightBarInUse)mComponents[0];
    }
    
    public void setLightBarInUse(LightBarInUse lightBarInUse)
    {
	mComponents[0] = lightBarInUse;
    }
    
    public boolean hasLightBarInUse()
    {
	return componentIsPresent(0);
    }
    
    public void deleteLightBarInUse()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "sireneInUse"
    public SireneInUse getSireneInUse()
    {
	return (SireneInUse)mComponents[1];
    }
    
    public void setSireneInUse(SireneInUse sireneInUse)
    {
	mComponents[1] = sireneInUse;
    }
    
    public boolean hasSireneInUse()
    {
	return componentIsPresent(1);
    }
    
    public void deleteSireneInUse()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "emergencyResponseType"
    public EmergencyResponseType getEmergencyResponseType()
    {
	return (EmergencyResponseType)mComponents[2];
    }
    
    public void setEmergencyResponseType(EmergencyResponseType emergencyResponseType)
    {
	mComponents[2] = emergencyResponseType;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "EmergencyVehicle"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "EmergencyVehicle"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"LightBarInUse"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"LightBarInUse"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unavailable",
					0
				    ),
				    new MemberListElement (
					"disabled",
					1
				    ),
				    new MemberListElement (
					"enabled",
					2
				    ),
				    new MemberListElement (
					"engaged",
					3
				    )
				}
			    ),
			    0,
			    LightBarInUse.unavailable
			)
		    ),
		    "lightBarInUse",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"SireneInUse"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"SireneInUse"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"unavailable",
					0
				    ),
				    new MemberListElement (
					"disabled",
					1
				    ),
				    new MemberListElement (
					"enabled",
					2
				    ),
				    new MemberListElement (
					"engaged",
					3
				    )
				}
			    ),
			    0,
			    SireneInUse.unavailable
			)
		    ),
		    "sireneInUse",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"EmergencyResponseType"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"EmergencyResponseType"
			    ),
			    12318,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"none",
					0
				    ),
				    new MemberListElement (
					"staticSafeguard",
					1
				    ),
				    new MemberListElement (
					"movingSafeguard",
					2
				    ),
				    new MemberListElement (
					"rightOfWay",
					3
				    )
				}
			    ),
			    0,
			    EmergencyResponseType.none
			)
		    ),
		    "emergencyResponseType",
		    2,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' EmergencyVehicle object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' EmergencyVehicle object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for EmergencyVehicle
