/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type VehicleCommonParameters from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class VehicleCommonParameters extends Sequence {
    
    /**
     * The default constructor.
     */
    public VehicleCommonParameters()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public VehicleCommonParameters(VehicleType vehicleType, 
		    StationLength stationLength, 
		    Confidence stationLengthConfidence, 
		    StationWidth stationWidth, 
		    Confidence stationWidthConfidence, 
		    VehicleSpeed vehicleSpeed, 
		    Confidence vehicleSpeedConfidence, 
		    LongAcceleration longAcceleration, 
		    Confidence longAccelerationConfidence, 
		    AccelerationControl accelerationControl, YawRate yawRate, 
		    Confidence yawRateConfidence, 
		    ExteriorLights exteriorLights, TurnAdvice turnAdvice, 
		    DistanceToStopLine distanceToStopLine, 
		    Occupancy occupancy, DoorOpen doorOpen, 
		    PosConfidenceEllipse posConfidenceEllipse, 
		    Curvature curvature, CurvatureChange curvatureChange, 
		    Confidence curvatureConfidence, CrashStatus crashStatus, 
		    Confidence headingConfidence, 
		    DangerousGoods dangerousGoods)
    {
	setVehicleType(vehicleType);
	setStationLength(stationLength);
	setStationLengthConfidence(stationLengthConfidence);
	setStationWidth(stationWidth);
	setStationWidthConfidence(stationWidthConfidence);
	setVehicleSpeed(vehicleSpeed);
	setVehicleSpeedConfidence(vehicleSpeedConfidence);
	setLongAcceleration(longAcceleration);
	setLongAccelerationConfidence(longAccelerationConfidence);
	setAccelerationControl(accelerationControl);
	setYawRate(yawRate);
	setYawRateConfidence(yawRateConfidence);
	setExteriorLights(exteriorLights);
	setTurnAdvice(turnAdvice);
	setDistanceToStopLine(distanceToStopLine);
	setOccupancy(occupancy);
	setDoorOpen(doorOpen);
	setPosConfidenceEllipse(posConfidenceEllipse);
	setCurvature(curvature);
	setCurvatureChange(curvatureChange);
	setCurvatureConfidence(curvatureConfidence);
	setCrashStatus(crashStatus);
	setHeadingConfidence(headingConfidence);
	setDangerousGoods(dangerousGoods);
    }
    
    /**
     * Construct with required components.
     */
    public VehicleCommonParameters(VehicleType vehicleType, 
		    StationLength stationLength, StationWidth stationWidth, 
		    VehicleSpeed vehicleSpeed, 
		    Confidence vehicleSpeedConfidence, 
		    LongAcceleration longAcceleration, 
		    Confidence longAccelerationConfidence, 
		    AccelerationControl accelerationControl, YawRate yawRate, 
		    Confidence yawRateConfidence, 
		    ExteriorLights exteriorLights, 
		    PosConfidenceEllipse posConfidenceEllipse, 
		    Curvature curvature, Confidence curvatureConfidence, 
		    Confidence headingConfidence)
    {
	setVehicleType(vehicleType);
	setStationLength(stationLength);
	setStationWidth(stationWidth);
	setVehicleSpeed(vehicleSpeed);
	setVehicleSpeedConfidence(vehicleSpeedConfidence);
	setLongAcceleration(longAcceleration);
	setLongAccelerationConfidence(longAccelerationConfidence);
	setAccelerationControl(accelerationControl);
	setYawRate(yawRate);
	setYawRateConfidence(yawRateConfidence);
	setExteriorLights(exteriorLights);
	setPosConfidenceEllipse(posConfidenceEllipse);
	setCurvature(curvature);
	setCurvatureConfidence(curvatureConfidence);
	setHeadingConfidence(headingConfidence);
    }
    
    public void initComponents()
    {
	mComponents[0] = new VehicleType();
	mComponents[1] = new StationLength();
	mComponents[2] = new Confidence();
	mComponents[3] = new StationWidth();
	mComponents[4] = new Confidence();
	mComponents[5] = new VehicleSpeed();
	mComponents[6] = new Confidence();
	mComponents[7] = new LongAcceleration();
	mComponents[8] = new Confidence();
	mComponents[9] = new AccelerationControl();
	mComponents[10] = new YawRate();
	mComponents[11] = new Confidence();
	mComponents[12] = new ExteriorLights();
	mComponents[13] = new TurnAdvice();
	mComponents[14] = new DistanceToStopLine();
	mComponents[15] = new Occupancy();
	mComponents[16] = new DoorOpen();
	mComponents[17] = new PosConfidenceEllipse();
	mComponents[18] = new Curvature();
	mComponents[19] = new CurvatureChange();
	mComponents[20] = new Confidence();
	mComponents[21] = new CrashStatus();
	mComponents[22] = new Confidence();
	mComponents[23] = new DangerousGoods();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[24];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new VehicleType();
	    case 1:
		return new StationLength();
	    case 2:
		return new Confidence();
	    case 3:
		return new StationWidth();
	    case 4:
		return new Confidence();
	    case 5:
		return new VehicleSpeed();
	    case 6:
		return new Confidence();
	    case 7:
		return new LongAcceleration();
	    case 8:
		return new Confidence();
	    case 9:
		return new AccelerationControl();
	    case 10:
		return new YawRate();
	    case 11:
		return new Confidence();
	    case 12:
		return new ExteriorLights();
	    case 13:
		return new TurnAdvice();
	    case 14:
		return new DistanceToStopLine();
	    case 15:
		return new Occupancy();
	    case 16:
		return new DoorOpen();
	    case 17:
		return new PosConfidenceEllipse();
	    case 18:
		return new Curvature();
	    case 19:
		return new CurvatureChange();
	    case 20:
		return new Confidence();
	    case 21:
		return new CrashStatus();
	    case 22:
		return new Confidence();
	    case 23:
		return new DangerousGoods();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "vehicleType"
    public VehicleType getVehicleType()
    {
	return (VehicleType)mComponents[0];
    }
    
    public void setVehicleType(VehicleType vehicleType)
    {
	mComponents[0] = vehicleType;
    }
    
    
    // Methods for field "stationLength"
    public StationLength getStationLength()
    {
	return (StationLength)mComponents[1];
    }
    
    public void setStationLength(StationLength stationLength)
    {
	mComponents[1] = stationLength;
    }
    
    
    // Methods for field "stationLengthConfidence"
    public Confidence getStationLengthConfidence()
    {
	return (Confidence)mComponents[2];
    }
    
    public void setStationLengthConfidence(Confidence stationLengthConfidence)
    {
	mComponents[2] = stationLengthConfidence;
    }
    
    public boolean hasStationLengthConfidence()
    {
	return componentIsPresent(2);
    }
    
    public void deleteStationLengthConfidence()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "stationWidth"
    public StationWidth getStationWidth()
    {
	return (StationWidth)mComponents[3];
    }
    
    public void setStationWidth(StationWidth stationWidth)
    {
	mComponents[3] = stationWidth;
    }
    
    
    // Methods for field "stationWidthConfidence"
    public Confidence getStationWidthConfidence()
    {
	return (Confidence)mComponents[4];
    }
    
    public void setStationWidthConfidence(Confidence stationWidthConfidence)
    {
	mComponents[4] = stationWidthConfidence;
    }
    
    public boolean hasStationWidthConfidence()
    {
	return componentIsPresent(4);
    }
    
    public void deleteStationWidthConfidence()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "vehicleSpeed"
    public VehicleSpeed getVehicleSpeed()
    {
	return (VehicleSpeed)mComponents[5];
    }
    
    public void setVehicleSpeed(VehicleSpeed vehicleSpeed)
    {
	mComponents[5] = vehicleSpeed;
    }
    
    
    // Methods for field "vehicleSpeedConfidence"
    public Confidence getVehicleSpeedConfidence()
    {
	return (Confidence)mComponents[6];
    }
    
    public void setVehicleSpeedConfidence(Confidence vehicleSpeedConfidence)
    {
	mComponents[6] = vehicleSpeedConfidence;
    }
    
    
    // Methods for field "longAcceleration"
    public LongAcceleration getLongAcceleration()
    {
	return (LongAcceleration)mComponents[7];
    }
    
    public void setLongAcceleration(LongAcceleration longAcceleration)
    {
	mComponents[7] = longAcceleration;
    }
    
    
    // Methods for field "longAccelerationConfidence"
    public Confidence getLongAccelerationConfidence()
    {
	return (Confidence)mComponents[8];
    }
    
    public void setLongAccelerationConfidence(Confidence longAccelerationConfidence)
    {
	mComponents[8] = longAccelerationConfidence;
    }
    
    
    // Methods for field "accelerationControl"
    public AccelerationControl getAccelerationControl()
    {
	return (AccelerationControl)mComponents[9];
    }
    
    public void setAccelerationControl(AccelerationControl accelerationControl)
    {
	mComponents[9] = accelerationControl;
    }
    
    
    // Methods for field "yawRate"
    public YawRate getYawRate()
    {
	return (YawRate)mComponents[10];
    }
    
    public void setYawRate(YawRate yawRate)
    {
	mComponents[10] = yawRate;
    }
    
    
    // Methods for field "yawRateConfidence"
    public Confidence getYawRateConfidence()
    {
	return (Confidence)mComponents[11];
    }
    
    public void setYawRateConfidence(Confidence yawRateConfidence)
    {
	mComponents[11] = yawRateConfidence;
    }
    
    
    // Methods for field "exteriorLights"
    public ExteriorLights getExteriorLights()
    {
	return (ExteriorLights)mComponents[12];
    }
    
    public void setExteriorLights(ExteriorLights exteriorLights)
    {
	mComponents[12] = exteriorLights;
    }
    
    
    // Methods for field "turnAdvice"
    public TurnAdvice getTurnAdvice()
    {
	return (TurnAdvice)mComponents[13];
    }
    
    public void setTurnAdvice(TurnAdvice turnAdvice)
    {
	mComponents[13] = turnAdvice;
    }
    
    public boolean hasTurnAdvice()
    {
	return componentIsPresent(13);
    }
    
    public void deleteTurnAdvice()
    {
	setComponentAbsent(13);
    }
    
    
    // Methods for field "distanceToStopLine"
    public DistanceToStopLine getDistanceToStopLine()
    {
	return (DistanceToStopLine)mComponents[14];
    }
    
    public void setDistanceToStopLine(DistanceToStopLine distanceToStopLine)
    {
	mComponents[14] = distanceToStopLine;
    }
    
    public boolean hasDistanceToStopLine()
    {
	return componentIsPresent(14);
    }
    
    public void deleteDistanceToStopLine()
    {
	setComponentAbsent(14);
    }
    
    
    // Methods for field "occupancy"
    public Occupancy getOccupancy()
    {
	return (Occupancy)mComponents[15];
    }
    
    public void setOccupancy(Occupancy occupancy)
    {
	mComponents[15] = occupancy;
    }
    
    public boolean hasOccupancy()
    {
	return componentIsPresent(15);
    }
    
    public void deleteOccupancy()
    {
	setComponentAbsent(15);
    }
    
    
    // Methods for field "doorOpen"
    public DoorOpen getDoorOpen()
    {
	return (DoorOpen)mComponents[16];
    }
    
    public void setDoorOpen(DoorOpen doorOpen)
    {
	mComponents[16] = doorOpen;
    }
    
    public boolean hasDoorOpen()
    {
	return componentIsPresent(16);
    }
    
    public void deleteDoorOpen()
    {
	setComponentAbsent(16);
    }
    
    
    // Methods for field "posConfidenceEllipse"
    public PosConfidenceEllipse getPosConfidenceEllipse()
    {
	return (PosConfidenceEllipse)mComponents[17];
    }
    
    public void setPosConfidenceEllipse(PosConfidenceEllipse posConfidenceEllipse)
    {
	mComponents[17] = posConfidenceEllipse;
    }
    
    
    // Methods for field "curvature"
    public Curvature getCurvature()
    {
	return (Curvature)mComponents[18];
    }
    
    public void setCurvature(Curvature curvature)
    {
	mComponents[18] = curvature;
    }
    
    
    // Methods for field "curvatureChange"
    public CurvatureChange getCurvatureChange()
    {
	return (CurvatureChange)mComponents[19];
    }
    
    public void setCurvatureChange(CurvatureChange curvatureChange)
    {
	mComponents[19] = curvatureChange;
    }
    
    public boolean hasCurvatureChange()
    {
	return componentIsPresent(19);
    }
    
    public void deleteCurvatureChange()
    {
	setComponentAbsent(19);
    }
    
    
    // Methods for field "curvatureConfidence"
    public Confidence getCurvatureConfidence()
    {
	return (Confidence)mComponents[20];
    }
    
    public void setCurvatureConfidence(Confidence curvatureConfidence)
    {
	mComponents[20] = curvatureConfidence;
    }
    
    
    // Methods for field "crashStatus"
    public CrashStatus getCrashStatus()
    {
	return (CrashStatus)mComponents[21];
    }
    
    public void setCrashStatus(CrashStatus crashStatus)
    {
	mComponents[21] = crashStatus;
    }
    
    public boolean hasCrashStatus()
    {
	return componentIsPresent(21);
    }
    
    public void deleteCrashStatus()
    {
	setComponentAbsent(21);
    }
    
    
    // Methods for field "headingConfidence"
    public Confidence getHeadingConfidence()
    {
	return (Confidence)mComponents[22];
    }
    
    public void setHeadingConfidence(Confidence headingConfidence)
    {
	mComponents[22] = headingConfidence;
    }
    
    
    // Methods for field "dangerousGoods"
    public DangerousGoods getDangerousGoods()
    {
	return (DangerousGoods)mComponents[23];
    }
    
    public void setDangerousGoods(DangerousGoods dangerousGoods)
    {
	mComponents[23] = dangerousGoods;
    }
    
    public boolean hasDangerousGoods()
    {
	return componentIsPresent(23);
    }
    
    public void deleteDangerousGoods()
    {
	setComponentAbsent(23);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "VehicleCommonParameters"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "VehicleCommonParameters"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"VehicleType"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"VehicleType"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new VehicleType(0), 
				    new VehicleType(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "vehicleType",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"StationLength"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"StationLength"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new StationLength(0), 
				    new StationLength(16383),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(16383)
			    ),
			    null
			)
		    ),
		    "stationLength",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "stationLengthConfidence",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"StationWidth"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"StationWidth"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new StationWidth(0), 
				    new StationWidth(16383),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(16383)
			    ),
			    null
			)
		    ),
		    "stationWidth",
		    3,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "stationWidthConfidence",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"VehicleSpeed"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"VehicleSpeed"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new VehicleSpeed(-32765), 
				    new VehicleSpeed(32765),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-32765),
				new java.lang.Long(32765)
			    ),
			    null
			)
		    ),
		    "vehicleSpeed",
		    5,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "vehicleSpeedConfidence",
		    6,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8007
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"LongAcceleration"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"LongAcceleration"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new LongAcceleration(-2000), 
				    new LongAcceleration(2000),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-2000),
				new java.lang.Long(2000)
			    ),
			    null
			)
		    ),
		    "longAcceleration",
		    7,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8008
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "longAccelerationConfidence",
		    8,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8009
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"AccelerationControl"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"AccelerationControl"
			    ),
			    12314,
			    null,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"brakePedal",
					0
				    ),
				    new MemberListElement (
					"throttlePedal",
					1
				    ),
				    new MemberListElement (
					"cruiseControl",
					2
				    ),
				    new MemberListElement (
					"acc",
					3
				    ),
				    new MemberListElement (
					"limiter",
					4
				    ),
				    new MemberListElement (
					"brakeAssist",
					5
				    )
				}
			    )
			)
		    ),
		    "accelerationControl",
		    9,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x800a
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"YawRate"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"YawRate"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "YawRate"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "YawRate"
				)
			    ),
			    0
			)
		    ),
		    "yawRate",
		    10,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x800b
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "yawRateConfidence",
		    11,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x800c
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"ExteriorLights"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ExteriorLights"
			    ),
			    12314,
			    null,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"lowBeamHeadlightsOn",
					0
				    ),
				    new MemberListElement (
					"highBeamHeadlightsOn",
					1
				    ),
				    new MemberListElement (
					"leftTurnSignalOn",
					2
				    ),
				    new MemberListElement (
					"rightTurnSignalOn",
					3
				    ),
				    new MemberListElement (
					"automaticLightControlOn",
					4
				    ),
				    new MemberListElement (
					"daytimeRunningLightsOn",
					5
				    ),
				    new MemberListElement (
					"fogLightOn",
					6
				    ),
				    new MemberListElement (
					"parkingLightsOn",
					7
				    )
				}
			    )
			)
		    ),
		    "exteriorLights",
		    12,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x800d
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"TurnAdvice"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"TurnAdvice"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "TurnAdvice"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "TurnAdvice"
				)
			    ),
			    0
			)
		    ),
		    "turnAdvice",
		    13,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x800e
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DistanceToStopLine"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"DistanceToStopLine"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DistanceToStopLine(0), 
				    new DistanceToStopLine(65535),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(65535)
			    ),
			    null
			)
		    ),
		    "distanceToStopLine",
		    14,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x800f
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Occupancy"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Occupancy"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Occupancy(0), 
				    new Occupancy(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "occupancy",
		    15,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new BitStringInfo (
			    new Tags (
				new short[] {
				    (short)0x8010
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DoorOpen"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"DoorOpen"
			    ),
			    12314,
			    null,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"driver",
					0
				    ),
				    new MemberListElement (
					"passenger",
					1
				    ),
				    new MemberListElement (
					"maintenance",
					2
				    ),
				    new MemberListElement (
					"luggage",
					3
				    )
				}
			    )
			)
		    ),
		    "doorOpen",
		    16,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8011
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"PosConfidenceEllipse"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"PosConfidenceEllipse"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "PosConfidenceEllipse"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "PosConfidenceEllipse"
				)
			    ),
			    0
			)
		    ),
		    "posConfidenceEllipse",
		    17,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8012
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Curvature"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Curvature"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Curvature(-32765), 
				    new Curvature(32765),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-32765),
				new java.lang.Long(32765)
			    ),
			    null
			)
		    ),
		    "curvature",
		    18,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8013
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"CurvatureChange"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"CurvatureChange"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new CurvatureChange(-1023), 
				    new CurvatureChange(1023),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(-1023),
				new java.lang.Long(1023)
			    ),
			    null
			)
		    ),
		    "curvatureChange",
		    19,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8014
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "curvatureConfidence",
		    20,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new TypeInfo (
			    new Tags (
				new short[] {
				    (short)0x8015
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"CrashStatus"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"CrashStatus"
			    ),
			    12314,
			    null
			)
		    ),
		    "crashStatus",
		    21,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8016
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Confidence"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Confidence"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new Confidence(0), 
				    new Confidence(15),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(15)
			    ),
			    null
			)
		    ),
		    "headingConfidence",
		    22,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8017
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DangerousGoods"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"DangerousGoods"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DangerousGoods(0), 
				    new DangerousGoods(8191),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(8191)
			    ),
			    null
			)
		    ),
		    "dangerousGoods",
		    23,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8007, 7)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8008, 8)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8009, 9)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800b, 11)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800c, 12)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800d, 13),
			new TagDecoderElement((short)0x800e, 14),
			new TagDecoderElement((short)0x800f, 15),
			new TagDecoderElement((short)0x8010, 16),
			new TagDecoderElement((short)0x8011, 17)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800e, 14),
			new TagDecoderElement((short)0x800f, 15),
			new TagDecoderElement((short)0x8010, 16),
			new TagDecoderElement((short)0x8011, 17)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800f, 15),
			new TagDecoderElement((short)0x8010, 16),
			new TagDecoderElement((short)0x8011, 17)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8010, 16),
			new TagDecoderElement((short)0x8011, 17)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8011, 17)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8012, 18)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8013, 19),
			new TagDecoderElement((short)0x8014, 20)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8014, 20)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8015, 21),
			new TagDecoderElement((short)0x8016, 22)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8016, 22)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8017, 23)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' VehicleCommonParameters object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' VehicleCommonParameters object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for VehicleCommonParameters
